
package de.ivu.elect.exchange.gebietsbaum;

import java.io.IOException;
import java.io.OutputStream;
import java.util.List;
import java.util.zip.ZipOutputStream;

import javax.annotation.Nullable;
import javax.inject.Inject;

import de.ivu.elect.EmlExportMapper;
import de.ivu.elect.EmlExportMapperHelper;
import de.ivu.elect.business.datei.entity.Datei;
import de.ivu.elect.business.datei.entity.FileType;
import de.ivu.elect.business.exchange.control.FileFormat;
import de.ivu.elect.business.exchange.control.FileKonfiguration;
import de.ivu.elect.business.exchange.control.MappingException;
import de.ivu.elect.business.gebietsbaum.boundary.GebietDAO;
import de.ivu.elect.business.gebietsbaum.boundary.NlGebietDarstellungNummerFormatter;
import de.ivu.elect.business.gebietsbaum.control.GebietByBreadthFirstComparator;
import de.ivu.elect.business.gebietsbaum.control.Gebietsbaum;
import de.ivu.elect.business.gebietsbaum.control.GebietsbaumExchangeContext;
import de.ivu.elect.business.gebietsbaum.entity.Gebiet;
import de.ivu.elect.business.gebietsbaum.entity.Wahldurchfuehrungsgebiet;
import de.ivu.elect.business.security.boundary.EmlSignKeyService;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.nl.eml.EmlWrapper;
import de.ivu.elect.nl.eml.readable.Eml110bContestWrapper;
import de.ivu.elect.nl.eml.readable.Eml110bWrapper;
import de.ivu.elect.nl.eml.readable.PollingPlaceWrapper;
import de.ivu.elect.util.FileUtil;
import de.ivu.elect.was.exchange.wahl.Eml110Mapper;
import de.ivu.elect.wus.exchange.gebietsbaum.Eml110bStimmbezirkImportMapper;
import de.ivu.wahl.wus.oasis.eml.VotingChannelType;
import org.apache.commons.lang3.StringUtils;

public class Eml110bGebietsbaumExportMapper implements GebietsbaumExportMapper, EmlExportMapper {

  public static final String EML110B_CONTEST_ID = "geen";

  @Inject
  private transient GebietDAO gebietDAO;

  @Inject
  private transient Eml110Mapper eml110Mapper;

  @Inject
  private transient EmlExportMapperHelper emlExportMapperHelper;

  @Inject
  private transient EmlSignKeyService emlSignKeyService;

  @Inject
  private transient Messages messages;

  @Inject
  private transient NlGebietDarstellungNummerFormatter nlGebietDarstellungNummerFormatter;

  public Eml110bGebietsbaumExportMapper() {
    super();
  }

  @Override
  public void serialize(Gebietsbaum gebietsbaum, OutputStream os, GebietsbaumExchangeContext context, FileKonfiguration fileKonfiguration) throws MappingException {
    Wahl wahl = gebietsbaum.getWahl();

    if (wahl == null) {
      return;
    }

    List<Gebiet> gebiete = gebietsbaum.getGebiete();
    gebiete.sort(new GebietByBreadthFirstComparator());

    Gebiet oberstesGebiet = gebiete.stream().filter(g -> !g.hasUebergeordnetesGebiet()).findFirst().orElse(null);

    if (oberstesGebiet == null) {
      return;
    }

    EmlWrapper emlWrapper = EmlWrapper.createEml("110b");

    Eml110bWrapper eml110bWrapper = new Eml110bWrapper(emlWrapper.getContent());
    eml110bWrapper.getManagingAuthority().setAuthorityId(nlGebietDarstellungNummerFormatter.formatiereNummer(oberstesGebiet));
    eml110bWrapper.getManagingAuthority().setAuthorityName(oberstesGebiet.getName());

    eml110Mapper.mappeWahldaten(wahl, oberstesGebiet, gebietsbaum::getGebiete, eml110bWrapper.getElectionIdentifier110a(), true /* ELECTVAPP-1277 */);

    Eml110bContestWrapper contest = eml110bWrapper.getContest();
    contest.getContent().getContestIdentifier().setId(EML110B_CONTEST_ID);
    contest.setUebergeordnetesGebietName(oberstesGebiet.getName());
    contest.setUebergeordnetesGebietNummer(StringUtils.leftPad(oberstesGebiet.getNummer(), 4, '0')); // ELECTVAPP-1280

    for (Gebiet gebiet : gebiete) {
      if (gebiet.getGebietsart().getBezirksart().isBezirk()) {
        PollingPlaceWrapper pollingPlaceWrapper = contest.addPollingPlace();
        pollingPlaceWrapper.setId(gebiet.getNummer());
        pollingPlaceWrapper.setName(gebiet.getName());

        if (gebiet.isBriefwahlgebiet()) {
          pollingPlaceWrapper.setChannel(VotingChannelType.POSTAL);
        } else {
          pollingPlaceWrapper.setChannel(VotingChannelType.POLLING);
        }

        if (gebiet.isInstanceOf(Wahldurchfuehrungsgebiet.class)) {
          Wahldurchfuehrungsgebiet wahldurchfuehrungsgebiet = gebiet.castTo(Wahldurchfuehrungsgebiet.class).getEntity();

          if (wahldurchfuehrungsgebiet.getAnzahlWahlberechtigterGesamtA1A2A3() != null) {
            pollingPlaceWrapper.setAnzahlWahlberechitige(Long.toString(wahldurchfuehrungsgebiet.getAnzahlWahlberechtigterGesamtA1A2A3()));
          }
        }

        pollingPlaceWrapper.setZipCode(gebiet.getAnschrift().getPlz());
      }
    }

    try (ZipOutputStream zos = new ZipOutputStream(os)) {
      emlExportMapperHelper.writeEml(emlWrapper, zos, FileUtil.normalizeZipEntryNamePreserveCase("Stembureaus_" + wahl.getKennzeichen() + "_" + oberstesGebiet.getName()) + EML_FILE_EXTENSION,
          oberstesGebiet, context, retrievePrivateKey(wahl, context, emlSignKeyService), retrievePublicKey(wahl, context, emlSignKeyService), retrieveNlX509Metadata(wahl, context, emlSignKeyService));

      zos.finish();
    } catch (IOException e) {
      throw new MappingException(e.getMessage(), e);
    }
  }

  @Override
  public FileFormat getFileFormat() {
    return new FileFormat(Eml110bStimmbezirkImportMapper.FILE_FORMAT, FileType.ZIP);
  }

  @Override
  public boolean isAcceptContext(GebietsbaumExchangeContext context) {
    return context.getWahl() != null && isStimmbezirkeVorhanden(context.getWahl());
  }

  private boolean isStimmbezirkeVorhanden(Wahl wahl) {
    return Eml110bStimmbezirkImportMapper.isStimmbezirkeVorhanden(wahl, gebietDAO);
  }

  @Override
  public boolean isSignEml(Wahl wahl) {
    return false; // nicht notwendig siehe https://confluence.ivu.de/pages/viewpage.action?spaceKey=VAPP&title=EML-Import+validation
  }

  @Override
  public void addProperties(FormBuilder formBuilder, GebietsbaumExchangeContext context, @Nullable Datei datei) {
    addSignProperties(context.getWahl(), formBuilder, context, messages);
  }
}
